;***************************************************************
;*                                                             *
;*  	                    STARTUP                            *
;*                                                             *
;*              Copyright 2001 Jaguar Devlopment Club          *
;*                                                             *
;*                   Programmed By Lars Hannig                 *
;*                                                             *
;*                                                             *
;***************************************************************
	.text
	.68000


JOY_UP		EQU	20		;joypad
JOY_DOWN	EQU	21
JOY_LEFT	EQU	22
JOY_RIGHT	EQU	23

FIRE_A		EQU	29		;fire buttons
FIRE_B		EQU	25
FIRE_C		EQU	13

;PRO CONTROLLER SUPPORT
;******************************
FIRE_X          EQU     1
FIRE_Y          EQU     5
FIRE_Z          EQU     17
FIRE_L          EQU     18
FIRE_R          EQU     2
;******************************
OPTION		EQU	9
PAUSE		EQU	28

KEY_STAR	EQU	16		;keypad
KEY_7           EQU     17
KEY_4           EQU     18
KEY_1		EQU	19

KEY_0		EQU	4
KEY_8           EQU     5
KEY_5		EQU	6
KEY_2		EQU	7

KEY_HASH	EQU	0
KEY_9           EQU     1
KEY_6           EQU     2
KEY_3		EQU	3

ANY_JOY		EQU	$00F00000	; AND joyedge with this - joypad was pressed if result is not 0
ANY_FIRE	EQU	$32002200	; AND joyedge with this - A,B C, Option or Pause was pressed if result is not 0
ANY_KEY		EQU	$000F00FF	; AND joyedge with this - 123456789*0# was pressed if result is not 0

;===========================================================================================
readpad:
;scan for player 1
	move.l	#$f0fffffc,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading
	move.w	#$81fe,JOYSTICK
	move.l	JOYSTICK,d0		; Read joypad, pause button, A button
	or.l	d1,d0			; Mask off unused bits
	ror.l	#4,d0
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	move.w	#$81fd,JOYSTICK
	move.l	JOYSTICK,d0		; Read *741 keys, B button
	or.l	d1,d0			; Mask off unused bits
	ror.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
	move.w	#$81fb,JOYSTICK
	move.l	JOYSTICK,d0		; Read 2580 keys, C button
	or.l	d1,d0			; Mask off unused bits
	rol.l	#6,d0
	rol.l	#6,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
	move.w	#$81f7,JOYSTICK
	move.l	JOYSTICK,d0		; Read 369# keys, Option button
	or.l	d1,d0			; Mask off unused bits
	rol.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low
	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high
	move.l	joycur,d0		; old joycur needed for determining the new joyedge
	move.l	d1,joycur		; Current joypad reading stored into joycur
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge		;joypad, buttons, keys that were just pressed
;scan for player 2
	move.l	#$0ffffff3,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading
	move.w	#$817f,JOYSTICK
	move.l	JOYSTICK,d0		; Read joypad, pause button, A button
	or.l	d1,d0			; Mask off unused bits
	rol.b	#2,d0			; note the size of rol
	ror.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	move.w	#$81bf,JOYSTICK
	move.l	JOYSTICK,d0		; Read *741 keys, B button
	or.l	d1,d0			; Mask off unused bits
	rol.b	#2,d0			; note the size of rol
	ror.l	#8,d0
	ror.l	#4,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxxxxxxx xxxxxxxx
	move.w	#$81df,JOYSTICK
	move.l	JOYSTICK,d0		; Read 2580 keys, C button
	or.l	d1,d0			; Mask off unused bits
	rol.b	#2,d0			; note the size of rol
	rol.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxxx 2580xxxx
	move.w	#$81ef,JOYSTICK
	move.l	JOYSTICK,d0		; Read 369# keys, Option button
	or.l	d1,d0			; Mask off unused bits
	rol.b	#2,d0			; note the size of rol
	rol.l	#4,d0
	and.l	d0,d2			; d2 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== inputs active low
	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high
	move.l	joycur+4,d0		; old joycur needed for determining the new joyedge
	move.l	d1,joycur+4		; Current joypad reading stored into joycur
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge+4		;joypad, buttons, keys that were just pressed
	rts

joyedge::		dc.l		0,0
joycur::		dc.l		0,0
;================================================================================================
readmouse1:
;scan for player 1
	move.l	#$f0fffffc,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading
	move.w	#$81fe,JOYSTICK
	move.l	JOYSTICK,d0		; Read joypad, pause button, A button
	or.l	d1,d0			; Mask off unused bits
	ror.l	#4,d0			; note the size of rol
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high
	move.l	d1,d2
	and.l	#$30000000,d2
	move.w	#0,d4
	move.w	mouseY_last1,d3
	btst.l	#JOY_RIGHT,d1
	beq.s	.m_l1
	add.w	#2,d4
.m_l1:
	btst.l	#JOY_LEFT,d1
	beq.s	.m_rl1
	sub.w	#1,d4
.m_rl1:
	cmp.w	d3,d4
	beq.s	.m_u1
	swap	d3
	move.w	d4,d3	;d3 = #OldValue<<16+NewValue
	cmp.l	#$00020001,d3  ; is NewValue = 1 and was OldValue = 2 ?
	beq.s	.m_rl_pos1	   ; if yes, the sample is ok and it direction is positive
	cmp.l	#$0001ffff,d3
	beq.s	.m_rl_pos1	
	cmp.l	#$ffff0000,d3
	beq.s	.m_rl_pos1	
	cmp.l	#$00000002,d3
	beq.s	.m_rl_pos1	
	bra	.m_rl_neg1
.m_rl_pos1:
	bset.l	#JOY_DOWN,d2
	bra	.m_u1
.m_rl_neg1:
	cmp.l	#$ffff0001,d3
	beq.s	.m_rl_neg21
	cmp.l	#$00010002,d3
	beq.s	.m_rl_neg21
	cmp.l	#$00020000,d3
	beq.s	.m_rl_neg21
	cmp.l	#$0000ffff,d3
	bne.s	.m_u1	
.m_rl_neg21:
	bset.l	#JOY_UP,d2
	bra	.m_u1
.m_u1:	move.w	#0,d6
	move.w	mouseX_last1,d5	; durch Unwissen bei der Verdrahtung sind
				; die Joyporteingnge U+D fr XA+XB zustndig!
	btst.l	#JOY_DOWN,d1
	beq.s	.m_d1
	add.w	#2,d6		; XA = 1
.m_d1:	btst.l	#JOY_UP,d1
	beq.s	.m_ud1
	sub.w	#1,d6		; XB = 1
.m_ud1:	cmp.w	d5,d6	; wenn neuer Wert = alter Wert, dann weiter
	beq.s	.m_end1
	swap	d5
	move.w	d6,d5	;#AlterWert,NeuerWert
	cmp.l	#$00020001,d5
	beq.s	.m_ud_pos1	
	cmp.l	#$0001ffff,d5
	beq.s	.m_ud_pos1	
	cmp.l	#$ffff0000,d5
	beq.s	.m_ud_pos1	
	cmp.l	#$00000002,d5
	beq.s	.m_ud_pos1	
	bra	.m_ud_neg1
.m_ud_pos1:
	bset.l	#JOY_RIGHT,d2
	bra	.m_end1
.m_ud_neg1:
	cmp.l	#$ffff0001,d5
	beq.s	.m_ud_neg21
	cmp.l	#$00010002,d5
	beq.s	.m_ud_neg21
	cmp.l	#$00020000,d5
	beq.s	.m_ud_neg21
	cmp.l	#$0000ffff,d5
	bne.s	.m_end1	
.m_ud_neg21:
	bset.l	#JOY_LEFT,d2
	bra	.m_end1

.m_end1:	move.w	d4,mouseY_last1
	move.w	d6,mouseX_last1
	move.l	d2,d1

	move.l	joycur,d0		; old joycur needed for determining the new joyedge
	move.l	d1,joycur		; Current joypad reading stored into joycur
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge		;joypad, buttons, keys that were just pressed
	rts
readmouse2:
;scan for player 2
	move.l	#$0ffffff3,d1		; d1 = Joypad data mask
	moveq.l	#-1,d2			; d2 = Cumulative joypad reading
	move.w	#$817f,JOYSTICK
	move.l	JOYSTICK,d0		; Read joypad, pause button, A button
	or.l	d1,d0			; Mask off unused bits
	rol.b	#2,d0			; note the size of rol
	ror.l	#8,d0
	and.l	d0,d2			; d2 = xxAPxxxx RLDUxxxx xxxxxxxx xxxxxxxx
	moveq.l	#-1,d1
	eor.l	d2,d1			; d1 = xxAPxxBx RLDU741* xxCxxxOx 2580369# <== now inputs active high
	move.l	d1,d2
	and.l	#$30000000,d2
	move.w	#0,d4
	move.w	mouseY_last,d3
	btst.l	#JOY_RIGHT,d1
	beq.s	.m_l
	add.w	#2,d4
.m_l:
	btst.l	#JOY_LEFT,d1
	beq.s	.m_rl
	sub.w	#1,d4
.m_rl:
	cmp.w	d3,d4
	beq.s	.m_u
	swap	d3
	move.w	d4,d3	;d3 = #OldValue<<16+NewValue
	cmp.l	#$00020001,d3  ; is NewValue = 1 and was OldValue = 2 ?
	beq.s	.m_rl_pos	   ; if yes, the sample is ok and it direction is positive
	cmp.l	#$0001ffff,d3
	beq.s	.m_rl_pos	
	cmp.l	#$ffff0000,d3
	beq.s	.m_rl_pos	
	cmp.l	#$00000002,d3
	beq.s	.m_rl_pos	
	bra	.m_rl_neg
.m_rl_pos:
	bset.l	#JOY_DOWN,d2
	bra	.m_u
.m_rl_neg:
	cmp.l	#$ffff0001,d3
	beq.s	.m_rl_neg2
	cmp.l	#$00010002,d3
	beq.s	.m_rl_neg2
	cmp.l	#$00020000,d3
	beq.s	.m_rl_neg2
	cmp.l	#$0000ffff,d3
	bne.s	.m_u	
.m_rl_neg2:
	bset.l	#JOY_UP,d2
	bra	.m_u
.m_u:	move.w	#0,d6
	move.w	mouseX_last,d5	; durch Unwissen bei der Verdrahtung sind
				; die Joyporteingnge U+D fr XA+XB zustndig!
	btst.l	#JOY_DOWN,d1
	beq.s	.m_d
	add.w	#2,d6		; XA = 1
.m_d:	btst.l	#JOY_UP,d1
	beq.s	.m_ud
	sub.w	#1,d6		; XB = 1
.m_ud:	cmp.w	d5,d6	; wenn neuer Wert = alter Wert, dann weiter
	beq.s	.m_end
	swap	d5
	move.w	d6,d5	;#AlterWert,NeuerWert
	cmp.l	#$00020001,d5
	beq.s	.m_ud_pos	
	cmp.l	#$0001ffff,d5
	beq.s	.m_ud_pos	
	cmp.l	#$ffff0000,d5
	beq.s	.m_ud_pos	
	cmp.l	#$00000002,d5
	beq.s	.m_ud_pos	
	bra	.m_ud_neg
.m_ud_pos:
	bset.l	#JOY_RIGHT,d2
	bra	.m_end
.m_ud_neg:
	cmp.l	#$ffff0001,d5
	beq.s	.m_ud_neg2
	cmp.l	#$00010002,d5
	beq.s	.m_ud_neg2
	cmp.l	#$00020000,d5
	beq.s	.m_ud_neg2
	cmp.l	#$0000ffff,d5
	bne.s	.m_end	
.m_ud_neg2:
	bset.l	#JOY_LEFT,d2
	bra	.m_end

.m_end:	move.w	d4,mouseY_last
	move.w	d6,mouseX_last
	move.l	d2,d1

	move.l	joycur2,d0		; old joycur needed for determining the new joyedge
	move.l	d1,joycur2		; Current joypad reading stored into joycur
	eor.l	d1,d0
	and.l	d1,d0
	move.l	d0,joyedge2		;joypad, buttons, keys that were just pressed
	rts
joyedge2::		dc.l		0,0
joycur2::		dc.l		0,0

;******************************************************************************
; Subroutine copy OP List                                                     *
;******************************************************************************
copy_olist:
	lea	olist_ram,a0		; Adresse der erstellen OP Liste
	lea	olist,a1		; Adresse der OP Liste, die der OP beim Bildaufbau verwendet
.10:	move.l	(a0),(a1)+		; OP Liste von "olist_ram" nach "olist" kopieren
        	cmpi.l  	#4,(a0)+                ; Wert 4 kennzeichnet das STOP Object
	bne.b	.10			; Wiederhole bis komplette OP Liste kopiert ist
	rts				; Ende Unterprogramm



;******************************************************************************
; ATARI'S VIDEO STUFF                                                         *
; Check if NTSC or PAL                                                        *
; For now assume NTSC                                                         *
;******************************************************************************
;;; The following mask will extract the PAL/NTSC flag bit from the
;;; CONFIG register. NTSC = Bit Set, PAL = Bit Clear
VIDTYPE		EQU	$10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Procedure: InitVideo (same as in vidinit.s)
;            Build values for hdb, hde, vdb, and vde and store them.
;

VideoIni:
                movem.l 	d0-d6,-(sp)
                move.w  	CONFIG,d0                ; Also is joystick register
                andi.w  	#VIDTYPE,d0              ; 0 = PAL, 1 = NTSC
                beq     	palvals

                move.w  	#NTSC_HMID,d2
                move.w  	#NTSC_WIDTH,d0
                move.w  	#NTSC_VMID,d6
                move.w  	#NTSC_HEIGHT,d4
                bra     	calc_vals
palvals:
                move.w  	#PAL_HMID,d2
                move.w  	#PAL_WIDTH,d0
                move.w  	#PAL_VMID,d6
                move.w  	#PAL_HEIGHT,d4
calc_vals:
                move.w  	d0,width
                move.w  	d4,height
                move.w  	d0,d1
                asr     	#1,d1                   ; Width/2
                sub.w   	d1,d2                   ; Mid - Width/2
                add.w   	#4,d2                   ; (Mid - Width/2)+4
                sub.w   	#1,d1                   ; Width/2 - 1
                ori.w   	#$400,d1                ; (Width/2 - 1)|$400
                move.w  	d1,a_hde
                move.w  	d1,HDE
                move.w  	d2,a_hdb
                move.w  	d2,HDB1
                move.w  	d2,HDB2
                move.w  	d6,d5
                sub.w   	d4,d5
                move.w  	d5,a_vdb
                add.w   	d4,d6
                move.w  	d6,a_vde
                move.w  	a_vdb,VDB
                move.w  	#$FFFF,VDE
                move.l  	#0,BORD1                ; Black border
                move.l  	#0,BG
                movem.l 	(sp)+,d0-d6
                rts

;******************************************************************************
; Unterprogramm VBL Interrupt abwarten                                        *
;******************************************************************************
wait_int:
	move.b	framecnt,d0
.10:	cmp.b	intcount,d0
	bgt.b	.10
	clr.b	intcount
	rts

intcount:	dc.b	0
framecnt:	dc.b	1

;******************************************************************************
; Unterprogramm Interrupts initalisieren                                      *
;******************************************************************************
IntInit:
	move.l	LEVEL2,s_level2
	move.l	VI,s_vi
	move.l	INT1,s_int1
	move.w	sr,s_sr

        	move.l  	#Frame,LEVEL2

        	move.w  	a_vde,d0
        	ori.w    	#1,d0
	move.w  	#1,VI                   ; Get the maximum VBLANK time

	move.w  	INT1,d0
        	ori.w   	#1,d0
	move.w  	#1,INT1

	move.w  	sr,d0
	and.w   	#$f8ff,d0               ; Lower the 68K IPL
	move.w  	d0,sr
        	rts


	.QPHRASE
s_level2:	dc.l    	0
s_vi:      	dc.l    	0
s_int1:	dc.l    	0
s_sr:	dc.w    	0



;******************************************************************************
; VBL Interrupt Routine                                                       *
;******************************************************************************
Frame:  	movem.l 	d0-d7/a0-a6,-(sp)       ; benutzte Register retten
	jsr	copy_olist		; OP Liste kopieren
	add.b	#1,intcount
	move.w	#$101,INT1
	move.w	#0,INT2
        	movem.l 	(sp)+,d0-d7/a0-a6       ; Register wiederherstellen
	rte



;******************************************************************************
; Unterprogramm OP Liste erstellen (aus dem ATARI Entwicklungspaket)          *
;******************************************************************************
build:
;A1 = need address of first object
;D6 = total number of objects to be processed

;register use
;A0 is the address of the object list used by the object processor
;A2 is the address of the object list being built
;D0 holds the long being built
;D1 is used for temporary calculations
;D2 is the lines off screen,calculated in set_odata,used by set_oheight
;D3 is #12 for shifting d0
;D4 is #10 for shifting d0
;D5 is #11 for shifting d0
;D6 counts the objects being processed
;D7 is the address of the boject used by the object processor divided by 8

	moveq	#12,d3			;for doing lsl.l on d0
	moveq	#10,d4			;for doing lsl.l on d0
	moveq	#11,d5			;for doing lsl.l on d0
	move.l	#olist,d7		;address of packed olist
	lsr.l	#3,d7			;divide by 8 for object processor
	lea	olist_ram,a2		;address of copy of packed olist
	sub.w	#1,d6			;start dbra counter at total objects - 1
proc_obj:				;process an object
	tst.b	O_TYPE(a1)		;check the delete flag for this object
	bmi	next_obj		;skip this object if negative bit is set

;PHRASE 1
set_odata:
;if the object is above top line of the screen,
;the data pointer is set to the first line of the object that is on screen
	move.l	O_DATA(a1),d0		;get normal data address
        	moveq   	#0,d2                   ; Neu !!!!!!!
        	sub.w   	O_YPOS(a1),d2           ;top of screen - ypos = half lines off top of screen
        	bpl.b   	.05                     ;if object is above top of screen,use normal data address
        	clr.w   	d2                      ;0 lines off screen,use normal data address
        	bra.b   	.10
.05:    	lsr.w   	#1,d2                   ;convert half lines to lines
        	move.w  	O_DWIDTH(a1),d1         ;get phrases per line of data in the object
        	lsl.w   	#3,d1                   ;multiply phrases * 8 bytes per phrase
        	mulu.w  	d2,d1                   ;lines off screen * bytes per line in the object
        	add.l   	d1,d0                   ;skip the total bytes that are off the top of the screen
.10:	lsr.l	#3,d0			;divide by 8
	lsl.l	d5,d0			;shift left 11 bits to make room for link pointer

;set the link pointer to the next object
	add.l	#4,d7			;next object is 4 phrases ahead
	move.l	d7,d1			;get address in olist of next object

	lsr.l	#8,d1			;the rightmost 8 bits go in the next long,so remove them
	or.l	d1,d0			;or with data pointer
	move.l	d0,(a2)+		;save first long in phrase 1,advance the pointer to next long

	move.b	d7,d0			;get the low 8 bits of the link pointer that was saved earlier
	lsl.l	d4,d0			;shift left 10 bits to make room for height

set_oheight:
;d2.w is set to the number of lines that are above the top of the screen
;if part of the object is above the top line of the screen,
;the height is reduced by the number of lines off the top of the screen
        	move.w  	O_HEIGHT(a1),d1         ;get the height of the object
	cmpi.b	#1,O_TYPE(a1)		;see if this is a scaled bit map object
	bne.b	.10			;branch if object is not scaled
	sub.w	#1,d1			;an extra line is displayed at the bottom of the object if this is not here
.10:	sub.w	d2,d1			;subtract lines off screen from scaled height
	bmi.b	.20			;if lines off screen > height,make height 0 instead of negative
	or.w	d1,d0	        	;or with link pointer in second half of phrase 1
.20:	lsl.l	d5,d0			;shift left 11 bits to make room for ypos

set_oypos:
;if ypos is negative,it gets set to 0
;set_odata and set_oheight will adjust the data pointer and height accordingly
	move.w	O_YPOS(a1),d1
        	add.w   	a_vdb,d1                ; + Wert erste darstellbare Zeile

	bmi.b	.10			;if ypos is negative,object would not be displayed,so set ypos to 0
	and.w	#$7ff,d1		;only write 11 bits for ypos
	or.w	d1,d0			;or with link pointer and height
.10:	lsl.l	#3,d0			;shift left 3 bits to make room for type

set_otype:
	or.b	O_TYPE(a1),d0		;object type
	move.l	d0,(a2)+		;write second half of phrase 1

;PHRASE 2
set_ofirstpix:
	move.b	O_FIRSTPIX(a1),d0
	lsl.l	#4,d0			;shift left 4 bits to make room for release,transparent,rmw,reflect bits

set_flags:
	or.b	O_FLAGS(a1),d0		;or with firstpix
	lsl.l	#7,d0			;shift left 7 bits to make room for index

set_oindex:
	or.b	O_INDEX(a1),d0		;or with firstpix and flags
	lsl.l	#6,d0			;shift left 6 bits to make room for part of iwidth

set_oiwidth:
	move.w	O_IWIDTH(a1),d1
	lsr.w	#4,d1			;right 4 bits go in the next long,so remove them
	or.b	d1,d0
	move.l	d0,(a2)+		;write first long of phrase 2

	move.w	O_IWIDTH(a1),d0
	and.w	#$F,d0			;get low 4 bits of iwidth
	lsl.l	d4,d0			;shift left 10 bits to make room for dwidth

set_odwidth:
	or.w	O_DWIDTH(a1),d0 	;or with part of iwidth
	lsl.l	#3,d0			;shift left 3 bits to make room for pitch

set_opitch:
	or.b	O_PITCH(a1),d0		;or with dwidth and iwidth
	lsl.l	#3,d0			;shift left 3 bits to make room for depth

set_odepth:
	or.b	O_DEPTH(a1),d0		;or with dwidth,iwidth,pitch
	lsl.l	d3,d0			;shift left 12 bits to make room for xpos

set_oxpos:
        	move.w  	O_XPOS(a1),d1           ;object xpos
	and.w	#$fff,d1		;only write 12 bits for xpos
	or.w	d1,d0   		;or with the rest of the stuff
	move.l	d0,(a2)+		;write second half of phrase 2

;PHRASE 3
;for scaled bit map object only
	move.l	O_SCALE(a1),4(a2)	;write remainder,vscale,hscale bytes in 2nd long of phrase 3
	adda.l	#16,a2			;move pointer past the last 2 phrases for current object

next_obj:				;jump to here if delete flag is on
	adda.l	#OBJSIZE,a1		;point to next object in pseudo object list
	dbra	d6,proc_obj		;repeat until all objects have been processed

;write a stop object at the end of the list
	move.l	#0,(a2)+
        	move.l  	#4,(a2)                 ;write object type 4 (stop object)
 	rts



;******************************************************************************
; Branch Objekte erstellen                                                   *
;******************************************************************************
create_branch:
        	move.l  	olist_stop,d2           ; Adresse STOP Objekt
        	lea     	olist_branch,a0         ; Adresse Branch Objekte


; Erstes Branch Objekt (branch if YPOS > a_vde )

        	clr.l   	d1
        	move.l  	#(BRANCHOBJ|O_BRLT),d0  ; $4000 = VC < YPOS

        	andi.l  	#$3FFFF8,d2             ; Ensure alignment/valid address
        	move.l  	d2,d3                   ; Make a copy

        	swap    	d2                      ; Put bits 10-3 in bits 31-24
        	clr.w   	d2
        	lsl.l   	#5,d2
        	or.l    	d2,d0

        	lsr.l   	#8,d3                   ; Put bits 21-11 in bits 42-32
        	lsr.l   	#3,d3
        	or.l    	d3,d1

        	move.w  	a_vde,d3                ; for YPOS
        	lsl.w   	#3,d3                   ; Make it bits 13-3
        	or.w    	d3,d0

        	move.l  	d1,(a0)+
        	move.l  	d0,(a0)+                ; First OBJ is done.


; Zweites Branch Objekt (branch if YPOS < a_vdb)

        	andi.l  	#$FF000007,d0           ; Mask off CC and YPOS
        	ori.l   	#O_BRGT,d0              ; $8000 = VC > YPOS
        	move.w  	a_vdb,d3                ; for YPOS
        	lsl.w   	#3,d3                   ; Make it bits 13-3
        	or.w    	d3,d0

        	move.l  	d1,(a0)+                ; Second OBJ is done
        	move.l  	d0,(a0)+
        	rts




        .QPHRASE
	.bss
height: 	.ds.w    	1
a_vdb:  	.ds.w    	1
a_vde:  	.ds.w    	1
width:  	.ds.w    	1
a_hdb:  	.ds.w    	1
a_hde:  	.ds.w    	1
mouseX_last:   	.ds.w  	1
mouseY_last:   	.ds.w  	1
mouseX_last1:   	.ds.w  	1
mouseY_last1:   	.ds.w  	1



.text

