;***********************************************************
;*                Projet : Blitter bit Expansion           *
;*                Fichier : main                 *
;*                Auteur : SCPCD                  *
;*                Date :                     *
;*          (c) scpcd                             *
;* Commentaire : example de bit2pixel expansion            *
;* CHANGES BY:    DO =  Matthias Domin
;***********************************************************
	.text
	.68000	;compiler pour le 68000
	.noclear
	
	include	"include.inc"   ;inclure "include" pour les definitions des equ
	
TOTAL_OBJS	equ	1               ;nombre d'objets pour la liste d'objets
;***********************************************************
c_start:
	move.w	#$100,JOYSTICK              ;mettre le son sur mute
	move.l	#0,G_CTRL                   ;arreter le GPU
	move.l	#0,D_CTRL                   ;arreter le DSP
	move.l	#0,G_FLAGS                  ;initialiser les FLAGS du GPU
	move.l	#0,D_FLAGS                  ;initialiser les FLAGS du DSP
	move.l	#$00070007,G_END            ;GPU en mode BigEndian (mode compatible 68000)
	move.l	#$00070007,D_END            ;DSP en mode BigEndian
	move.w	#%11010111001100,MEMCON2    ;memoire en mode BigEndian
;                           DCBA9876543210


    ; DO: Clear the "textscreen"-object (8 rows of 160 16bit pixels)
    lea.l   $100000,a0
    move.l  #8*(160*2)/4-1,d0
    move.l  #$ffffffff,d1   ; Yellow in CRY-mode
.clearscreensprite:
    move.l  d1,(a0)+
    dbf     d0,.clearscreensprite
    ; DO

	bsr	VideoIni                    ;initialiser le systeme video
	bsr	IntInit                     ;initialiser les interruptions
	
	move.w	#TOTAL_OBJS,d6              ;nombre d'objets pour la creation de la liste des objets
	lea	obj_data,a1                 ;adresse des donnees pour l'op liste
	bsr	build                       ;initialise l'op liste
	bsr	copy_olist                  ;copie l'op liste
	move.l	#olist,d0                   ;charge l'adresse de dpart pour l'op liste
	swap	d0                          ;interverti les la partie haute et basse de d0
	move.l	d0,OLP                      ;ecrit l'adresse de dpart pour l'op liste
	
	move.w	#%11011000001,VMODE         ;CRY, choisit la resolution
    ;move.w  #%11011000111,VMODE         ;RGB, choisit la resolution
;                           A9876543210
	
;***********************************************************
main::
	move.w	#TOTAL_OBJS,d6              ;nombre d'objets pour l'op liste
	lea	obj_data,a1                 ;adresse des donnees pour l'op liste
	bsr	build                       ;crer l'op liste
	bsr	wait_int                    ;attendre l'interruption VBL

	jsr	readpad                     ;lire les informations des PADS
	move.l	joycur,d0                   ;mettre dans d0 les donnees du PAD
	
	move.l	#0,adr_car
	
.check_left:
	move.l	#0,position
	bsr		efface_car
	btst.l	#JOY_LEFT,d0                ;test si JOY_LEFT est press
	beq	.check_right                ;sinon test pour joy_right
	lea	obj_data,a0                 ;charge l'adresse de l'objet  modifier
	sub.w	 #1,O_XPOS(a0)             ;dplace l'objet vers la gauche
	move.l	#font+8+(4*8),adr_car ;caractere fleche gauche
	bsr		bit2pixel

.check_right:
	move.l	#8,position
	bsr		efface_car
	btst.l	#JOY_RIGHT,d0               ;test si JOY_RIGHT est press
	beq	.check_up                   ;sinon test pour joy_up
	lea	obj_data,a0                 ;charge l'adresse de l'objet  modifier
	add.w	#1,O_XPOS(a0)             ;dplace l'objet vers la droite
	move.l	#font+8+(3*8),adr_car  ;caractere fleche droite
	bsr		bit2pixel
	
.check_up:
	move.l	#16,position
	bsr		efface_car
	btst.l	#JOY_UP,d0             ;test si JOY_UP est press
	beq	.check_down                 ;sinon test pour joy_down
	lea	obj_data,a0                 ;charge l'adresse de l'objet  modifier
	sub.w	#1,O_YPOS(a0)               ;dplace l'objet vers le haut
	move.l	#font+8+(1*8),adr_car ;caractere fleche haut
	bsr		bit2pixel
	
.check_down:
 	move.l	#24,position
	bsr		efface_car
	btst.l	#JOY_DOWN,d0                ;test si JOY_DOWN est press
	beq	.check_1                        ;sinon retourne  main
	lea	obj_data,a0                 ;charge l'adresse de l'objet  modifier
	add.w	#1,O_YPOS(a0)               ;dplace l'objet vers le bas
	move.l	#font+8+(2*8),adr_car  ;caractere fleche bas
	bsr		bit2pixel

.check_1:
 	move.l	#32,position
	bsr		efface_car
	btst.l	#KEY_1,d0
	beq	.check_2
	move.l	#font+8+(17*8),adr_car  ;caractere 1 segmente
	bsr		bit2pixel

.check_2:
	move.l	#40,position
	bsr		efface_car
	btst.l	#KEY_2,d0
             beq	.check_3
	move.l	#font+8+(18*8),adr_car  ;caractere 2 segmente
	bsr		bit2pixel
.check_3:
	move.l	#48,position
	bsr		efface_car
	btst.l	#KEY_3,d0
	beq	.check_4
	move.l	#font+8+(19*8),adr_car  ;caractere 3 segmente
	bsr		bit2pixel
.check_4:
	move.l	#56,position
	bsr		efface_car
	btst.l	#KEY_4,d0
	beq	.check_5
	move.l	#font+8+(20*8),adr_car  ;caractere 4 segmente
	bsr		bit2pixel
.check_5:
	move.l	#64,position
	bsr		efface_car
	btst.l	#KEY_5,d0
	beq	.check_6
	move.l	#font+8+(21*8),adr_car  ;caractere 5 segmente
	bsr		bit2pixel
.check_6:
	move.l	#72,position
	bsr		efface_car
	btst.l	#KEY_6,d0
	beq	.check_7
	move.l	#font+8+(22*8),adr_car  ;caractere 6 segmente
	bsr		bit2pixel
.check_7:
	move.l	#80,position
	bsr		efface_car
	btst.l	#KEY_7,d0
	beq	.check_8
	move.l	#font+8+(23*8),adr_car  ;caractere 7 segmente
	bsr		bit2pixel
.check_8:
	move.l	#88,position
	bsr		efface_car
	btst.l	#KEY_8,d0
	beq	.check_9
	move.l	#font+8+(24*8),adr_car  ;caractere 8 segmente
	bsr		bit2pixel
.check_9:
	move.l	#96,position
	bsr		efface_car
	btst.l	#KEY_9,d0
	beq	.check_0
	move.l	#font+8+(25*8),adr_car  ;caractere 9 segmente
	bsr		bit2pixel
.check_0:
	move.l	#104,position
	bsr		efface_car
	btst.l	#KEY_0,d0
	beq	.check_diese
	move.l	#font+8+(16*8),adr_car  ;caractere 0 segmente
	bsr		bit2pixel
.check_diese:
	move.l	#112,position
	bsr		efface_car
	btst.l	#KEY_HASH,d0
	beq	.check_etoile
	move.l	#font+8+(35*8),adr_car  ;caractere diese
	bsr		bit2pixel
.check_etoile:
	move.l	#120,position
	bsr		efface_car
	btst.l	#KEY_STAR,d0
	beq	main
	move.l	#font+8+(42*8),adr_car  ;caractere etoile
	bsr		bit2pixel
	bra	main



efface_car:     ;on efface le caractere
	move.l	#PITCH1|PIXEL16|WID160|XADDPIX,A1_FLAGS
	move.l	#$100000,A1_BASE
	move.l	position,A1_PIXEL	
	move.l	#0,A1_FPIXEL
	move.l	#$0001FFF8,A1_STEP
	move.l	#0,A1_FSTEP
	move.l	#$00080008,B_COUNT
	; DO: move.l	#$0,B_PATD
	; DO: move.l	#$0,B_PATD+4
    move.l  #$ffffffff,B_PATD     ; DO: Yellow in CRY-mode
    move.l  #$ffffffff,B_PATD+4   ; DO: Yellow in CRY-mode
	
	move.l	#PATDSEL|UPDA1,B_CMD
	rts

;fonction d'expansion de bit->pixel	
bit2pixel:
	move.l	#PITCH1|PIXEL1|WID64|XADDPIX,A1_FLAGS
	move.l	adr_car,A1_BASE      ;adresse du caractere
	move.l	#$00000000,A1_PIXEL
	move.l	#$00000000,A1_FPIXEL
	move.l	#$00000008,A1_STEP     ;permet de changer d'octet
	move.l	#$00000000,A1_FSTEP

	move.l	#PITCH1|PIXEL16|WID160|XADDPIX,A2_FLAGS
	move.l	#$100000,A2_BASE    ;adresse de l'objet
	move.l	position,A2_PIXEL   ;position du caractere
	move.l	#$0001FFF8,A2_STEP   ;permet de changer de ligne

	; DO: move.l	#$00007FFF,B_PATD    ;couleur du caractere
    move.l  #$00000000,B_PATD    ;DO: noir (BLACK) couleur du caractere
	move.l	#$00000000,B_PATD+4  ; seul 7FFF est utiliser les autres ne servent pas
	move.l	#$00080008,B_COUNT   ;caractere de 8*8
	
	;BCOMPEN : active le mode bit compare
	;le blitter test le bit en entree et si il vaut 0, il ne fait rien
	;si le bit est a 1 il ecrit la valeur 7FFF du B_PATD
	;SRCENX : permet de demarer le blitter autre que sur un debut de phrase
	;UPDA1 et UPDA2 permet d'actualiser les pointeurs par Ax_STEP
	move.l	#PATDSEL|BCOMPEN|UPDA1|UPDA2|DSTA2|SRCENX,B_CMD
	
	rts

;**********************************************************
	include	"jaguar2.inc"   ;inclure "jaguar2" pour les definitions des fonctions
;**********************************************************
	.QPHRASE
	rept	4
	dc.l	0
	endr
	
olist_branch:
	rept	4
	dc.l	0
	endr
	
olist:
	rept	((8*TOTAL_OBJS)+2)
	dc.l	0
	endr
	
olist_stop:
	dc.l	0
	dc.l	4
	
	.QPHRASE
olist_ram:
	rept	((8*TOTAL_OBJS)+2)
	dc.l	0
	endr
;*********************************************************

obj_data:
	dc.w	50                ;O_XPOS : position X de l'objet
	dc.w	50                ;O_YPOS : position Y de l'objet
	dc.l	$100000           ;O_DATA : adresse de l'image
	dc.w	8               ;O_HEIGHT : hauteur de l'objet en pixels
	dc.w	160/4             ;O_IWIDTH : largeur de l'objet en phrases
	dc.w	160/4             ;O_DWIDTH : offset de la prochaine ligne de l'objet en phrase (gnralement le meme que O_IWIDTH)
	dc.b	0                 ;O_FLAGS : facon que l'objet vat etre dessin
	dc.b	0                 ;O_FIRSTPIX : nombre de pixels qu'il faut sauter pour le dbut de l'objet
	dc.b	0                 ;O_TYPE : type de l'objet
	dc.b	4                 ;O_DEPTH : nombre de couleurs de l'objet
	dc.b	1                 ;O_PITCH : pitch
	dc.b	0                 ;O_INDEX : index dans la CLUT pour les objets avec une palette de couleur
	dc.w	$20               ;O_SCALE : remainder
	dc.b	20                ;O_XSCAL : facteur de scaling (X)
	dc.b	20                ;O_YSCAL : facteur de scaling (Y)
	
;**********************************************************
	.phrase
font:	incbin "ascii8x8.fnt"

	.phrase
	.bss
ypos:	ds.w	1
adr_car: ds.w	4
position: ds.w	4


	END
	
	
;***********************************************************
;*                            Fin                          *
;***********************************************************
